clear all
clc

CONS = {'C','D','G','J','S','T','Z','b','d','f','g','h','k','L','m','n','p','r','s','t','v','w','y','z'};
VOWS = {'@','A','E','I','O','R','U','W','Y','a','c','e','i','o','u'};
CON = 1;
VOW = 2;
% offest to con vow depending on position
INI = 2;
FIN = 4;

SUBJECTS = {'Alina','Angela','Anton','Bob','Carly','Edward','Evan','Joanna', 'Latisha','Laura','Miguel','Norene','Shauna','Teddy','Tony'};


for sbj = SUBJECTS
    count = zeros(6,length(CONS));
    correct = zeros(6,length(CONS));
    % Read in revised log files
    eval(['load(''../121128dataRevision/20121128newLogFiles/DataNSCM_' sbj{:}   '.mat'');'])
    eval(['trails = DataNSCM_' sbj{:} ';']);
    
    %count total number of consonants and vowel irrelvant of their poistion
    for trail_idx = 2 : length(trails)
        stimulus = trails{trail_idx,4};
        examiner = trails{trail_idx,5};
        transcriber1 = trails{trail_idx,6};
        transcriber2 = trails{trail_idx,7};
        % look at c or v individually
        for i=1:length(stimulus)
            % consonant or vowel?
            pos = find(strcmp(stimulus(i), CONS));
            if i == 1
                inifin = INI;
            else
                inifin = FIN;
            end
            if isempty(pos)
                pos = find(strcmp(stimulus(i), VOWS));
                convow = VOW;
            else
                convow = CON;
            end
            % count irrelevant of poistion
            count(convow,pos) = count(convow,pos) + 1;
            % count depending on positon
            count(convow + inifin, pos) = count(convow + inifin,pos) + 1;
            
            cor = logical(0);
            for j = 1 : length(examiner) 
                cor = cor || examiner(j)==stimulus(i); 
            end
            for j = 1 : length(transcriber1) 
                cor = cor || transcriber1(j)==stimulus(i); 
            end
            for j = 1 : length(transcriber2) 
                cor = cor || transcriber2(j)==stimulus(i); 
            end
            % correct count irrelevant of poistion
            correct(convow,pos) = correct(convow,pos) + cor;
            % correct count depending on poistion
            correct(convow+inifin,pos) = correct(convow+inifin,pos) + cor; 
        end
    end
    % Consonants
    xlswrite('xls/number_percent_correct.xls',{'Consonants'},sbj{1}, 'A1')
    % overall
    select = CON;
    xlswrite('xls/number_percent_correct.xls',{'Overall'},sbj{1}, 'B2')
    xlswrite('xls/number_percent_correct.xls',{'N','Cor', '% Cor'},sbj{1}, 'B3:D3')
    xlswrite('xls/number_percent_correct.xls',CONS',sbj{1}, 'A4:A27')
    xlswrite('xls/number_percent_correct.xls',{'Total'},sbj{1}, 'A28')
    xlswrite('xls/number_percent_correct.xls',[count(select,:)' correct(select,:)' (correct(select,:)./count(select,:))'; sum(count(select,:)) sum(correct(select,:)) sum(correct(select,:))/sum(count(select,:))],sbj{1}, 'B4:D28')
    % initial
    select = CON + INI;
    xlswrite('xls/number_percent_correct.xls',{'Initial'},sbj{1}, 'E2')
    xlswrite('xls/number_percent_correct.xls',{'N','Cor', '% Cor'},sbj{1}, 'E3:G3')
    xlswrite('xls/number_percent_correct.xls',[count(select,:)' correct(select,:)' (correct(select,:)./count(select,:))'; sum(count(select,:)) sum(correct(select,:)) sum(correct(select,:))/sum(count(select,:))],sbj{1}, 'E4:G28')
    % final
    select = CON + FIN;
    xlswrite('xls/number_percent_correct.xls',{'Final'},sbj{1}, 'H2')
    xlswrite('xls/number_percent_correct.xls',{'N','Cor', '% Cor'},sbj{1}, 'H3:J3')
    xlswrite('xls/number_percent_correct.xls',[count(select,:)' correct(select,:)' (correct(select,:)./count(select,:))'; sum(count(select,:)) sum(correct(select,:)) sum(correct(select,:))/sum(count(select,:))],sbj{1}, 'H4:J28')
    
    %Vowels
    xlswrite('xls/number_percent_correct.xls',{'Vowels'},sbj{1}, 'A30')
    % overall
    select = VOW;
    xlswrite('xls/number_percent_correct.xls',{'Overall'},sbj{1}, 'B31')
    xlswrite('xls/number_percent_correct.xls',{'N','Cor', '% Cor'},sbj{1}, 'B32:D32')
    xlswrite('xls/number_percent_correct.xls',VOWS',sbj{1}, 'A33:A47')
    xlswrite('xls/number_percent_correct.xls',{'Total'},sbj{1}, 'A48')
    xlswrite('xls/number_percent_correct.xls',[count(select,1:length(VOWS))' correct(select,1:length(VOWS))' (correct(select,1:length(VOWS))./count(select,1:length(VOWS)))'; sum(count(select,1:length(VOWS))) sum(correct(select,1:length(VOWS))) sum(correct(select,1:length(VOWS)))/sum(count(select,1:length(VOWS)))],sbj{1}, 'B33:D48')
    % initial
    select = VOW + INI;
    xlswrite('xls/number_percent_correct.xls',{'Initial'},sbj{1}, 'E31')
    xlswrite('xls/number_percent_correct.xls',{'N','Cor', '% Cor'},sbj{1}, 'E32:G32')
    xlswrite('xls/number_percent_correct.xls',[count(select,1:length(VOWS))' correct(select,1:length(VOWS))' (correct(select,1:length(VOWS))./count(select,1:length(VOWS)))'; sum(count(select,1:length(VOWS))) sum(correct(select,1:length(VOWS))) sum(correct(select,1:length(VOWS)))/sum(count(select,1:length(VOWS)))],sbj{1}, 'E33:G48')
    % final
    select = VOW + FIN;
    xlswrite('xls/number_percent_correct.xls',{'Final'},sbj{1}, 'H31')
    xlswrite('xls/number_percent_correct.xls',{'N','Cor', '% Cor'},sbj{1}, 'H32:J32')    
    xlswrite('xls/number_percent_correct.xls',[count(select,1:length(VOWS))' correct(select,1:length(VOWS))' (correct(select,1:length(VOWS))./count(select,1:length(VOWS)))'; sum(count(select,1:length(VOWS))) sum(correct(select,1:length(VOWS))) sum(correct(select,1:length(VOWS)))/sum(count(select,1:length(VOWS)))],sbj{1}, 'H33:J48')


end